//+------------------------------------------------------------------+

//|                                                Mega Trend EA.mq4 |

//|                      Copyright 2019,objemmanuel Software Corp. |

//|                                         objemmanuel@gmail.com |

//+------------------------------------------------------------------+

#property copyright "Copyright 2019,HamzaGhennami Software Corp."

#property link      "objemmanuel@gmail.com"

#property version   "1.00"

#property strict



string symbol=_Symbol;

extern bool isUseFilters = true;

extern int   MovingPeriod=50;

extern int    MovingShift   =0;

extern int    CciPeriod=14;

extern double LotSize=0.01;

extern bool AutoLotSizing=false;

extern double RiskPercent=0;

extern int TakeProfit=0;

extern int StopLoss=0;

extern bool UseTrailingStop=false;

extern int WhenToTrail=40;

extern int TrailAmount=20;

extern bool UsePartialClose=false;

extern int WhenPartialClose=40;

extern int PartialFacor=2;

extern int MagicNumber=22222;

double BSL=0,SSL=0,BTP=0,STP=0;

double pips=0;

//+------------------------------------------------------------------+

//| Expert initialization function                                   |

//+------------------------------------------------------------------+

int OnInit()

  {

//---
   double ticksize=MarketInfo(symbol,MODE_TICKSIZE);

   if(ticksize==0.00001 || ticksize==0.001)

      pips=ticksize*10;

   else
      pips=ticksize;

//---

   return(INIT_SUCCEEDED);

  }

//+------------------------------------------------------------------+

//| Expert deinitialization function                                 |

//+------------------------------------------------------------------+

void OnDeinit(const int reason)

  {

//---



  }

//+------------------------------------------------------------------+

//| Expert tick function                                             |

//+------------------------------------------------------------------+

void OnTick()

  {
//---Set value
   int DirectionsOfSignal=CheckForSignals();
   int FilterResults=0;
//---Check iMA if filter switch is enabled
   if(isUseFilters==true)
      FilterResults=CheckFilters();
//---Start operations in new candle
   if(IsNewCandle())
     {
      //---Open orders
      if(OpenOrdersThisPairBuy(symbol)==0 && OpenOrdersThisPairSell(symbol)==0)
        {
         if((DirectionsOfSignal==1)&&((FilterResults==1)||(isUseFilters==false)))
           OpenOrders(DirectionsOfSignal);
         if((DirectionsOfSignal==-1)&&((FilterResults==-1)||(isUseFilters==false)))
            OpenOrders(DirectionsOfSignal);
        }
      //---Close orders
      if((DirectionsOfSignal==-1)&&(OpenOrdersThisPairBuy(symbol)>0))
        CloseOrders(DirectionsOfSignal);
      if((DirectionsOfSignal==1)&&(OpenOrdersThisPairSell(symbol)>0))
         CloseOrders(DirectionsOfSignal);
     }
//---Trailing (I don't check this function)
   if(UseTrailingStop)
      AdjustTrail();

  }

//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool IsNewCandle()
  {

   static int BarsOnChart=0;

   if(Bars==BarsOnChart)

      return (false);

   BarsOnChart=Bars;

   return(true);

  }

//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int OpenOrders(int direction)
  {
   if(StopLoss!=0)
     {

      BSL=NormalizeDouble(Ask-StopLoss*pips,Digits);

      SSL=NormalizeDouble(Bid+StopLoss*pips,Digits);

     }
//---
   if(StopLoss!=0 && AutoLotSizing)
     {

      double pips_to_bsl=StopLoss*pips;

      double Equity=AccountEquity();

      double RiskedAmount=Equity*RiskPercent*0.01;

      LotSize=(RiskedAmount/(pips_to_bsl/pips))/10;

     }
//---
   if(TakeProfit!=0)
     {

      BTP=NormalizeDouble(Ask+TakeProfit*pips,Digits);

      STP=NormalizeDouble(Bid-TakeProfit*pips,Digits);

     }
//---Send orders
   if(direction==1)
      int BuyTicket=OrderSend(symbol,OP_BUY,LotSize,Ask,3,BSL,BTP,NULL,MagicNumber,0,clrGreen);

   if(direction==-1)
      int SellTicket=OrderSend(symbol,OP_SELL,LotSize,Bid,3,SSL,STP,NULL,MagicNumber,0,clrRed);
//---
   return(0);

  }

//+-------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int OpenOrdersThisPairBuy(string SYMBOL)
  {

   int total=0;

   for(int i=OrdersTotal()-1; i>=0; i--)

     {

      if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
         Print("error Selecting order ",GetLastError());

      if(OrderType()==0 && OrderMagicNumber()==MagicNumber && OrderSymbol()==SYMBOL)

         total++;

     }

   return (total);

  }

//+-------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int OpenOrdersThisPairSell(string SYMBOL)
  {

   int total=0;

   for(int i=OrdersTotal()-1; i>=0; i--)

     {

      if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
         Print("error Selecting order ",GetLastError());

      if(OrderType()==1 && OrderMagicNumber()==MagicNumber && OrderSymbol()==SYMBOL)

         total++;

     }

   return (total);

  }

//+-------------------------------------------------------------------+

void AdjustTrail()

  {

   for(int b=OrdersTotal()-1; b>=0; b--)

     {

      if(OrderSelect(b,SELECT_BY_POS,MODE_TRADES))

         if(OrderMagicNumber()==MagicNumber)

            if(OrderSymbol()==symbol)

               if(OrderType()==OP_BUY)

                  if(Bid-OrderOpenPrice()>WhenToTrail*pips)

                     if(OrderStopLoss()<Bid-TrailAmount*pips || OrderStopLoss()==0)

                        if(!OrderModify(OrderTicket(),OrderOpenPrice(),Bid-(TrailAmount*pips),OrderTakeProfit(),0,CLR_NONE))

                           Print("error modifying buy order ",GetLastError());



     }

   for(int s=OrdersTotal()-1; s>=0; s--)

     {

      if(OrderSelect(s,SELECT_BY_POS,MODE_TRADES))

         if(OrderMagicNumber()== MagicNumber)

            if(OrderSymbol()==symbol)

               if(OrderType()==OP_SELL)

                  if(OrderOpenPrice()-Ask>WhenToTrail*pips)

                     if(OrderStopLoss()>Ask+TrailAmount*pips || OrderStopLoss()==0)

                        if(!OrderModify(OrderTicket(),OrderOpenPrice(),Ask+(TrailAmount*pips),OrderTakeProfit(),0,CLR_NONE))

                           Print("error modifying sell order ",GetLastError());

     }

  }

//+-------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int CheckForSignals()
  {

   double x1,x2;


   x1 = iCCI(Symbol(),_Period,14,PRICE_TYPICAL,1);

   x2 = iCCI(Symbol(),_Period,14,PRICE_TYPICAL,2);

   if(x1>0 && x2<0)
      return(1);

   if(x1<0 && x2>0)
      return(-1);

   return(0);

  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int CheckFilters()
  {

   if(iClose(Symbol(),0,0)>iMA(NULL,0,MovingPeriod,MovingShift,MODE_EMA,PRICE_TYPICAL,0))
      return(1);

   if(iClose(Symbol(),0,0)<iMA(NULL,0,MovingPeriod,MovingShift,MODE_EMA,PRICE_TYPICAL,0))
      return(-1);

   return(0);

  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CloseOrders(int Direction)
  {
   bool ClosureOrder=false;
   for(int b=OrdersTotal()-1; b>=0; b--)
     {
      if(OrderSelect(b,SELECT_BY_POS,MODE_TRADES))
        {
         if(OrderMagicNumber()==MagicNumber && OrderSymbol()==symbol)
           {

            if((OrderType()==OP_BUY)&&(Direction==-1))
               ClosureOrder=OrderClose(OrderTicket(),OrderLots(),Bid,3,clrRed);
            if((OrderType()==OP_SELL)&&(Direction==1))
               ClosureOrder=OrderClose(OrderTicket(),OrderLots(),Ask,3,clrGreen);

           }
        }
     }
  }

//+-------------------------------------------------------------------+
